<template>
  <button @click="$emit('click')" :class="{ loading: loading }">
    <slot></slot>
  </button>
</template>

<script>
export default {
  name: 'custom-button',
  props: ['loading'],
}
</script>

<style lang="scss" scoped>
button {
  transition: color 0.15s;
}
.loading {
  color: transparent;
  pointer-events: none;
}
button:after {
  opacity: 0;
  transition: opacity 0.15s;
}
.loading.circle:after {
  margin-left: 0.01em;
  width: 0.5em;
  height: 0.5em;
}
.loading:after {
  // position
  position: absolute;
  margin-left: 0.25em;
  display: block;

  opacity: 1;

  // actual spinner
  border: 3px solid var(--foreground);
  border-top-left: none;
  border-radius: 290486px;
  border-color: transparent transparent var(--foreground) var(--foreground);
  animation: spinAround 0.5s infinite linear;

  content: '';
  width: 1em;
  height: 1em;
}
</style>
